#include "Module.h"

#include "Panel_CP2K.h"
#include "Command_template.h"

namespace MM
{

class Module_CP2K : public Module
{
    static Module_CP2K      singleton_;
                            Module_CP2K() ;
    void                    init ();

    void                    show_panel ();
};
Module_CP2K  Module_CP2K::singleton_;


Module_CP2K::Module_CP2K () : Module ("CP2K") { }

void  Module_CP2K::
init ()
{
    adopt_command (create_command (*this, &Module_CP2K::show_panel))
        .set_icon       ("Compute", "GAMESS.png")
        .set_tool_tip   ("Shell for CP2K quantum program.")
        .set_menu       ("&Tools", "&CP2K");
}

void  Module_CP2K::
show_panel ()
{
    Panel_CP2K::singleton()->popup ();
}

}//MM
