#ifndef NO_THERMOSTAT_H
#define NO_THERMOSTAT_H

#ifndef THERMOSTAT_H
#include "Thermostat.h"
#endif

#ifndef ATOM_GROUP_H
#include "Atom_group.h"
#endif

#ifndef MD_H
#include "MD.h"
#endif

#ifndef MODEL_H
#include "Model.h"
#endif

#ifndef CREATE_H
#include "Create.h"
#endif

namespace MM
{

class No_thermostat : public Thermostat
{
public:
    No_thermostat ()
    :   Thermostat (nil<Model>(), nil<Atom_group>(), nil<MD>())    { }

    char const* title () const      {return "No";}

    virtual void    handle_execute ()    {;}

    double              response_constant () const     {return 0.;}
    void                set_response_constant (double) {;}
};

}//MM

#endif //NO_THERMOSTAT_H
